clear

load regression_parameter

time=51;

% initial state
b_t(1)=0.0248;
s_t_bench(1)=0.4934;

for t=1:time-1
    yyy=feval('fun_result',b_t(t));
    g_t(t)=yyy(1,1); tau_t(t)=yyy(2,1);
    h_t(t)=(w*(1-tau_t(t))/X)^(1/xi);
    b_t(t+1)=g_t(t)+R*b_t(t)-w*h_t(t)*tau_t(t);
    g_gdp(t)=g_t(t)/(w*h_t(t));
    b_gdp(t)=b_t(t)/(w*h_t(t));
    c_t(t)=h_t(t)*w*(1-tau_t(t))+F-1/(1+xi)*X*h_t(t)^(1+xi);
    c_t_bench(t)=R*s_t_bench(t)+1/(1+bet)*c_t(t);
    s_t_bench(t+1)=bet/(1+bet)*c_t(t);
end

xxx=feval('fun_result',b_t(time));
g_t(time)=xxx(1,1);
tau_t(time)=xxx(2,1);
h_t(time)=(w*(1-tau_t(time))/X)^(1/xi);
g_gdp(time)=g_t(time)/(w*h_t(time));
b_gdp(time)=b_t(time)/(w*h_t(time));
c_t(time)=h_t(time)*w*(1-tau_t(time))+F-1/(1+xi)*X*h_t(time)^(1+xi);
me_t(time)=h_t(time)*w*(1-tau_t(time))/c_t(time);
c_t_bench(time)=R*s_t_bench(time)+1/(1+bet)*c_t(time);

% computing some elasticities
display('tax rate  g_ratio  debt_ratio market earnings ratio')
display([tau_t(time) g_gdp(time) b_gdp(time) me_t(time)])

plot([0:time-1],tau_t,'LineWidth',2,'Color','r')

% steady state
g_ss=g_t(time); tau_ss=tau_t(time); b_ss=b_t(time); gdp_ss=w*h_t(time);
save data_ss g_ss tau_ss b_ss gdp_ss

g_t_bench=g_t; tau_t_bench=tau_t; b_t_bench=b_t;
save data_bench g_t_bench tau_t_bench b_t_bench c_t_bench s_t_bench