function y=fun_regression_parameter(R)
   
global xi xi_i

% fixing the ratio of theta_o to theta_y
the_o_y=0.8479/0.3818;

%*********************************
% the country with fixed theta
%*********************************

% parameter
the=0.3697; % relative weight on government expenditure
the_o=the*the_o_y; % 0.9163; % theta for the old
% **** Note that alp = 1/3 cannot be adjusted ****
alp=1/3; % capital output elasticity 
% **** Note that alp = 1/3 cannot be adjusted ****
omi=0.25; % relative weight on the welfare of old households
% R=1.04^30; % gross interest rate
lam=0; % degree of altruism
phi=omi/(1-omi*(1-lam)); % useful parameter

% calibration
Q=(1/((1-alp)*(alp/1.04^30)^(alp/(1-alp))))^(1-alp);
w=(1-alp)*Q^(1/(1-alp))*(alp/R)^(alp/(1-alp)); % normalization of wage rate

% calibration
X=1.2221;
F=X/(1+xi); % the original F_0: F_0-X/(1+xi)*h^(1/(1+xi))

% calibrate beta
bet=0.4420;

% bound for tax
tau_max=xi/(1+xi);
tau_min=0;

% bound for debt
h_max=(w*(1-tau_min)/X)^(1/xi);
b_max=(tau_max*(w*(1-tau_max)/X)^(1/xi)*w)/(R-1);
b_min=0;

% order of chebyshev polynomial
ord=8;

% number of state grids
num=ord;

% range of grids
b_max_0=1*b_max;
b_min_0=0;

% define debt in general chebyshev polynomials
for i=1:num
    % the chebyshev collocation 
    vb(i)=cos((num*2-1-(i-1)*2)*pi/(2*num));
    b(i)=((vb(i)+1)*(b_max_0-b_min_0)+2*b_min_0)/2;
    vb(i)=2*(b(i)-b_min)/(b_max-b_min)-1;
end

% define the derivative of vb w.r.t. b
d_vb=2/(b_max-b_min);

save regression_parameter bet the the_o alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb

load solution_aa_1_c1
initial_aa_1=solution_aa_1;
options=optimset('Display','off','LargeScale','off');
[solution_aa_1,fval,exitflag,output,jacobian_0]=fsolve('projection_policy_1',initial_aa_1,options);

solution_aa_1=real(solution_aa_1);
save solution_aa_1 solution_aa_1 
save solution_aa_1_c1 solution_aa_1
savefile=['solution_aa_1_c1_xi_',num2str(xi_i),'.mat'];
save(savefile,'solution_aa_1');

evolution_calibration

tau_1=tau_t(time);
g_1=g_t(time);
debt_1=b_t(time);
gdp_1=w*h_t(time);
inc_1=h_t(time)*w*(1-tau_t(time))+F-1/(1+xi)*X*h_t(time)^(1+xi); % income of the young
con_1=1/(1+bet)*(h_t(time)*w*(1-tau_t(time))+F-1/(1+xi)*X*h_t(time)^(1+xi)+F/R); % consumption of the young
saving_1=inc_1-con_1;
sr_1=saving_1/(h_t(time)*w*(1-tau_t(time)));

%*********************************
% the country with fixed theta
%*********************************

% parameter
the=0.3937; % relative weight on government expenditure
the_o=the*the_o_y; % 0.9163; % theta for the old

save regression_parameter bet the the_o alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb

load solution_aa_1_c2
initial_aa_1=solution_aa_1;
[solution_aa_1,fval,exitflag,output,jacobian_0]=fsolve('projection_policy_1',initial_aa_1,options);

solution_aa_1=real(solution_aa_1);
save solution_aa_1 solution_aa_1 
save solution_aa_1_c2 solution_aa_1
savefile=['solution_aa_1_c2_xi_',num2str(xi_i),'.mat'];
save(savefile,'solution_aa_1');

evolution_calibration

tau_2=tau_t(time);
g_2=g_t(time);
debt_2=b_t(time);
gdp_2=w*h_t(time);
inc_2=h_t(time)*w*(1-tau_t(time))+F-1/(1+xi)*X*h_t(time)^(1+xi); % income of the young
con_2=1/(1+bet)*(h_t(time)*w*(1-tau_t(time))+F-1/(1+xi)*X*h_t(time)^(1+xi)+F/R); % consumption of the young
saving_2=inc_2-con_2;
sr_2=saving_2/(h_t(time)*w*(1-tau_t(time)));

% equation
k_gdp=(saving_1+saving_2-debt_1-debt_2)/(gdp_1+gdp_2);
y(1)=k_gdp-1/2/(R);

savefile=['two_country_ss_xi_',num2str(xi_i),'.mat'];
save(savefile,'R','tau_1','g_1','gdp_1','sr_1','debt_1','tau_2','g_2','gdp_2','debt_2','sr_2');


