xi_grid=[1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.8 2.0 2.5 3.0 3.5 4.5 5.0 5.5 6 7 8 9 10 12.5 15 17.5 20 25 27.5 30 32.5 35 40 45 50];
benchmark_grid=6;
xxx=size(xi_grid);
grid_max=xxx(2);

for i=1:grid_max
    
    loadfile=['two_country_ss_xi_',num2str(i)];
    load(loadfile)
    FE_x(i)=1/real(xi_grid(i)); R_x(i)=real(R); tau_1_x(i)=real(tau_1); debt_1_x(i)=real(debt_1); g_1_x(i)=real(g_1);
    tau_2_x(i)=real(tau_2); debt_2_x(i)=real(debt_2); g_2_x(i)=real(g_2);

end

% linear equilibrium
% fixing the ratio of theta_o to theta_y
the_o_y=0.8479/0.3818;
% parameter
the(1)=0.3697; % relative weight on government expenditure
the(2)=0.3937; % relative weight on government expenditure
the_o=the*the_o_y; % 0.9163; % theta for the old
% **** Note that alp = 1/3 cannot be adjusted ****
alp=1/3; % capital output elasticity 
% **** Note that alp = 1/3 cannot be adjusted ****
bet=0.4424;
omi=0.25; % relative weight on the welfare of old households
lam=the_o/the;
gam(1)=1/(1+(1-omi)*((1+bet)+the(1)*bet*lam)/(the(1)*(1+omi*(lam-1)))); % II using theta from the high-theta country !!!
gam(2)=1/(1+(1-omi)*((1+bet)+the(2)*bet*lam)/(the(2)*(1+omi*(lam-1)))); % II using theta from the high-theta country !!!
R_linear=1/((1-omi)*lam/(1+omi*(lam-1))*bet*gam(2)); % determined by the high-theta country !!!

% calibration
Q=(1/((1-alp)*(alp/1.04^30)^(alp/(1-alp))))^(1-alp);
w=(1-alp)*Q^(1/(1-alp))*(alp/R_linear)^(alp/(1-alp)); % normalization of wage rate
b_max=w/(R_linear-1);

% steady state capital in each economy
K=(alp*Q/R_linear)^(1/(1-alp));

% share of each country
nu=[0.5 0.5];
b_ss=b_max-(K-w+R_linear*b_max)/(nu(2)*(1-omi)*(1+lam*the(2))/((1+omi*(lam-1))*the(2))*gam(2)*R_linear*bet)
tau_ss=1-(1-omi)*(1+bet)/((1+omi*(lam-1))*the(2))*R_linear/w*gam(2)*(b_max-b_ss);
g_ss=R_linear*gam(2)*(b_max-b_ss);

% results
FE_x(grid_max+1)=0; R_x(grid_max+1)=R_linear; tau_1_x(grid_max+1)=1; debt_1_x(grid_max+1)=b_max; g_1_x(grid_max+1)=0;
tau_2_x(grid_max+1)=tau_ss; debt_2_x(grid_max+1)=b_ss; g_2_x(grid_max+1)=g_ss;


subplot(2,2,1)
plot(FE_x,(R_x).^(1/30)-1,'r -*','LineWidth',1)
box off
xlabel('\xi (Frisch Elasticity)')
title('panel a: annualized interest rate')
axis([0 1 0.03 0.07])
subplot(2,2,2)
plot(FE_x,debt_1_x,'r -*','LineWidth',1)
hold on
plot(FE_x,debt_2_x,'b -o','LineWidth',1)
hold off
box off
xlabel('\xi (Frisch Elasticity)')
title('panel b: public debt')
axis([0 1 -0.05 0.15])
subplot(2,2,3)
plot(FE_x,g_1_x,'r -*','LineWidth',1)
hold on
plot(FE_x,g_2_x,'b -o','LineWidth',1)
hold off
box off
xlabel('\xi (Frisch Elasticity)')
title('panel c: public good')
axis([0 1 0.0 0.4])
subplot(2,2,4)
plot(FE_x,tau_1_x,'r -*','LineWidth',1)
hold on
plot(FE_x,tau_2_x,'b -o','LineWidth',1)
hold off
box off
xlabel('\xi (Frisch Elasticity)')
title('panel d: tax rate')
axis([0 1 0 1])




