index_ini=1; % 1 for benchmark with xi=1.5
% country index
index_c=0; % index_c = 1 for country with LOWER theta !!!

% load solution_aa_1_c1_xi_50
% save solution_aa_1_c1 solution_aa_1
% load solution_aa_1_c2_xi_50
% save solution_aa_1_c2 solution_aa_1
% xi=50;

% initial: benchmark
if index_ini==1 
    if index_c == 1
        load solution_aa_1_c1_xi_benchmark
        save solution_aa_1_c1 solution_aa_1
    else
        load solution_aa_1_c2_xi_benchmark
        save solution_aa_1_c2 solution_aa_1
    end
    xi=1.5; R=1.04^30;
end

% computation
if index_c == 1
    the=0.3697; % relative weight on government expenditure for the young
else
    the=0.3937;
end
% parameter
the_o_y=0.8479/0.3818;
the_o=the*the_o_y; % theta for the old
% **** Note that alp = 1/3 cannot be adjusted ****
alp=1/3; % capital output elasticity 
% **** Note that alp = 1/3 cannot be adjusted ****
omi=0.25; % relative weight on the welfare of old households
% R=1.04^30; % gross interest rate
lam=0.0; % degree of altruism
phi=omi/(1-omi*(1-lam)); % useful parameter

% calibration
Q=(1/((1-alp)*(alp/1.04^30)^(alp/(1-alp))))^(1-alp);
w=(1-alp)*Q^(1/(1-alp))*(alp/R)^(alp/(1-alp)); % normalization of wage rate
% xi=1.5; % 1/xi = Frisch elasticity

% targeted wealth income ratio
k_gdp_target=1/2/(R);

% bound for tax
tau_max=xi/(1+xi);
tau_min=0;

X=1.2221;
F=X/(1+xi); % the original F_0: F_0-X/(1+xi)*h^(1/(1+xi))

% calibrate beta
bet=0.4420;

% bound for debt
h_max=(w*(1-tau_min)/X)^(1/xi);
b_max=(tau_max*(w*(1-tau_max)/X)^(1/xi)*w)/(R-1);
b_min=0;

% order of chebyshev polynomial
ord=8;

% number of state grids
num=ord;

% check the oder of old polynomial
if index_c == 1
    load solution_aa_1_c1
    size_solution_aa_1=size(solution_aa_1);
    num_old=size_solution_aa_1(1,1)/2;

    if num > num_old 
        aa(1:2*num,1)=0;
        aa(1:num_old,1)=solution_aa_1(1:num_old); 
        aa(num+1:num+num_old,1)=solution_aa_1(num_old+1:2*num_old);
        clear solution_aa_1
        solution_aa_1=aa;
        save solution_aa_1_c1 solution_aa_1
    elseif num < num_old
        aa(1:num,1)=solution_aa_1(1:num);
        aa(num+1:num+num,1)=solution_aa_1(num_old+1:num_old+num);
        clear solution_aa_1
        solution_aa_1=aa;
        save solution_aa_1_c1 solution_aa_1
    end
else
    load solution_aa_1_c2
    size_solution_aa_1=size(solution_aa_1);
    num_old=size_solution_aa_1(1,1)/2;

    if num > num_old 
        aa(1:2*num,1)=0;
        aa(1:num_old,1)=solution_aa_1(1:num_old); 
        aa(num+1:num+num_old,1)=solution_aa_1(num_old+1:2*num_old);
        clear solution_aa_1
        solution_aa_1=aa;
        save solution_aa_1_c2 solution_aa_1
    elseif num < num_old
        aa(1:num,1)=solution_aa_1(1:num);
        aa(num+1:num+num,1)=solution_aa_1(num_old+1:num_old+num);
        clear solution_aa_1
        solution_aa_1=aa;
        save solution_aa_1_c2 solution_aa_1
    end
end 

% range of grids
b_max_0=1*b_max;
b_min_0=b_min;

% define debt in general chebyshev polynomials
for i=1:num
    % the chebyshev collocation 
    vb(i)=cos((num*2-1-(i-1)*2)*pi/(2*num));
    b(i)=((vb(i)+1)*(b_max_0-b_min_0)+2*b_min_0)/2;
    vb(i)=2*(b(i)-b_min)/(b_max-b_min)-1;
end

% define the derivative of vb w.r.t. b
d_vb=2/(b_max-b_min);

save regression_parameter bet the the_o alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb

if index_c == 1
    save regression_parameter_c1 bet the the_o alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb
    load solution_aa_1_c1
else
    save regression_parameter_c2 bet the the_o alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb
    load solution_aa_1_c2
end
initial_aa_1=solution_aa_1;

% solving
options=optimset('Display','iter','LargeScale','off','NonlEqnAlgorithm','gn','MaxIter',50,'TolFun',1e-30,'TolX',1e-20);
[solution_aa_1,fval,exitflag,output,jacobian_0]=fsolve('projection_policy_1',initial_aa_1,options);
solution_aa_1=real(solution_aa_1);
save solution_aa_1 solution_aa_1

if index_c == 1
    save solution_aa_1_c1 solution_aa_1
    if index_ini == 1
        save solution_aa_1_c1_xi_6 solution_aa_1
    end
else
    save solution_aa_1_c2 solution_aa_1
    if index_ini == 1
        save solution_aa_1_c2_xi_6 solution_aa_1
    end
end

% result