% load parameter
clear

load regression_parameter

% initial guess of coefficients

% slope
load data_g_slope
load data_tau_slope

% define function: g(t)=G(b(t)) and tau(t)=T(b(t))
for j=1:num
    g(j,1)=g_slope(1,1)+g_slope(2,1)*b(j);
    tau(j,1)=tau_slope(1,1)+tau_slope(2,1)*b(j);
end

g_interpl=interp1(b_fortran,g_fortran,b);
tau_interpl=interp1(b_fortran,tau_fortran,b);
% for j=1:ord
%     tau_interpl(j)=0.3+4*b(j);
%     if tau_interpl(j) > 0.5
%         tau_interpl(j)=0.5;
%     end
% end
% 

% define chebyshev polynomial
ord_est=3; % order of polynomial used in estimating the initial guess
for j=1:num
    for s=1:ord_est
        % denote by che_b the T in chebyshev polynomial
        che_b(j,s)=cos((s-1)*acos(vb(j)));     
    end
end

% regression
initial_aa_g=regress(g_interpl',che_b);
initial_aa_tau=regress(tau_interpl',che_b);
initial_aa_1(1:2*num,1)=0;
initial_aa_1(1:ord_est,1)=initial_aa_g; 
initial_aa_1(num+1:num+ord_est,1)=initial_aa_tau;
save initial_aa_1 initial_aa_1
aa=initial_aa_1;

% original data
% clear initial_aa_1
% initial_aa_1=zeros(2*num,1);
% initial_aa_1(1,1)=0.1146; initial_aa_1(2,1)=-0.0259; initial_aa_1(3,1)=-0.0014;
% initial_aa_1(num+1,1)=0.3720; initial_aa_1(num+2,1)=0.0698; initial_aa_1(num+3,1)=-0.0055;
% save initial_aa_1 initial_aa_1
% aa=initial_aa_1;

% load solution_aa_1
% aa=solution_aa_1;

% define function: g(t)=B(b(t)) 
T=100; % num
for j=1:T
    b_x(j)=b(1)+(j-1)*(max(b)-b(1))/T;
    vb_x(j)=2*(b_x(j)-b_min)/(b_max-b_min)-1;
    % real_b(j)=0.1676+0.3592*b_x(j);
    
    % define function: b(t+1)=B(b(t)) 
    for s=1:ord
        % denote by che_b the T in chebyshev polynomial
        che_b_x(s)=cos((s-1)*acos(vb_x(j)));
        % elements of b(t+1)=B(b(t))
        g_aa_x(s)=aa(s)*che_b_x(s);
        tau_aa_x(s)=aa(ord+s)*che_b_x(s);
        % function: b(t+1)=B(b(t))
        g_x(j)=sum(g_aa_x);
        tau_x(j)=sum(tau_aa_x);
        g_x_test(j)=g_slope(1,1)+g_slope(2,1)*b_x(j);
        tau_x_test(j)=tau_slope(1,1)+tau_slope(2,1)*b_x(j);
    end
    
    % test
    h_x(j)=(w*(1-tau_x(j))/X)^(1/xi);
    e_x(j)=1/xi*tau_x(j)/(1-tau_x(j));
    A_x(j)=(1-tau_x(j))*w*h_x(j)+F-X/(1+xi)*h_x(j)^(1+xi);
    FOC_x(j)=A_x(j)*(1-e_x(j))-(1+bet)/(the*(1+phi))*g_x(j);

end

figure (1)
subplot(1,2,1)
plot(b_x,g_x,b_fortran,g_fortran)
subplot(1,2,2)
plot(b_x,tau_x,b_fortran,tau_fortran)
figure (2)
plot(b_x,FOC_x)
