load regression_parameter

T=100;

% range of grids
% b_max_0=0.999*b_max; % 0.145944178104401; % 0.9*b_max;
% b_min_0=0;

% define function: g(t)=B(b(t)) 
for j=1:T
    b_x(j)=b_min_0+(j-1)*(b_max_0-b_min_0)/(T-1);
    yyy=feval('fun_result',b_x(j));
    g_x(j)=yyy(1,1); tau_x(j)=yyy(2,1);
    h_x(j)=(w*(1-tau_x(j))/X)^(1/xi);
    b1_x(j)=g_x(j)+R*b_x(j)-w*h_x(j)*tau_x(j);
    c_x(j)=h_x(j)*w*(1-tau_x(j))+F-1/(1+xi)*X*h_x(j)^(1+xi);
    g_gdp(j)=g_x(j)/(w*h_x(j));
    b_gdp(j)=b_x(j)/(w*h_x(j));
    b1_gdp(j)=b1_x(j)/(w*h_x(j));
end

% linear equilibrium
lamd=the_o/the;
if index_c == 1
    load regression_parameter_c2
end
II=1/(1+(1-omi)*((1+bet)+the*bet*lamd)/(the*(1+omi*(lamd-1)))); % II using theta from the high-theta country !!!
R_linear=1/((1-omi)*lamd/(1+omi*(lamd-1))*bet*II); % determined by the high-theta country !!!
load regression_parameter
if index_c == 1
    II=1/(1+(1-omi)*((1+bet)+the*bet*lamd)/(the*(1+omi*(lamd-1)))); % II for own country
end
for j=1:T
    b1_linear(j)=b_max-(1-omi)*lamd/(1+omi*(lamd-1))*bet*R_linear*II*(b_max-b_x(j));
end

figure (1)
subplot(1,1,1)
plot(b_x,b1_x,'b -','LineWidth',2)
hold on
plot(b_x,b1_linear,'r :','LineWidth',2)
hold on
plot(b_x,b_x,'k -')
% set(gca,'xtick',[0 0.05 0.10 0.15 0.22])
% set(gca,'ytick',[0.05 0.10 0.15 0.22])
legend('FE=0.02','linear')
axis([0 b_max 0 b_max])
xlabel('debt')
ylabel('next-period debt')
hold off
box off

subplot(2,2,1)
plot(b_x,tau_x,'b -','LineWidth',2)
% set(gca,'xtick',[0 0.05 0.10 0.15 0.22])
% set(gca,'ytick',[0.10 0.20 0.30 0.40 0.50])
axis([0 b_max 0.2 0.601])
xlabel('debt')
ylabel('tax rate')
title('panel a')
box off

subplot(2,2,2)
plot(b_x,g_x,'r -','LineWidth',2)
% set(gca,'xtick',[0 0.05 0.10 0.15 0.22])
% set(gca,'ytick',[0.05 0.10 0.15 0.20])
axis([0 b_max 0 0.301])
xlabel('debt')
ylabel('public spending')
title('panel b')
box off

subplot(2,2,3)
plot(b_x,b1_x,'g -','LineWidth',2)
hold on
plot(b_x,b1_linear,'g -','LineWidth',2)
hold on
plot(b_x,b_x,'k -')
% set(gca,'xtick',[0 0.05 0.10 0.15 0.22])
% set(gca,'ytick',[0.05 0.10 0.15 0.22])
axis([0 b_max 0 b_max])
xlabel('debt')
ylabel('next-period debt')
title('panel c')
hold off
box off

time=51;
clear b_t g_t tau_t h_t

% initial state
b_t(1)=0.0001;
b_t_linear(1)=b_t(1);

for t=1:time-1
    yyy=feval('fun_result',b_t(t));
    g_t(t)=yyy(1,1); tau_t(t)=yyy(2,1);
    h_t(t)=(w*(1-tau_t(t))/X)^(1/xi);
    b_t(t+1)=g_t(t)+R*b_t(t)-w*h_t(t)*tau_t(t);
    b_t_linear(t+1)=b_max-(1-omi)*lamd/(1+omi*(lamd-1))*bet*R_linear*II*(b_max-b_t_linear(t));
end

xxx=feval('fun_result',b_t(time));
g_t(time)=xxx(1,1);
tau_t(time)=xxx(2,1);

load data_b_ramsey
subplot(2,2,4)
plot([0:time-1],b_t,'g -','LineWidth',2)
% set(gca,'ytick',[0.01 0.02 0.03 0.04 0.05])
hold on
plot([0:time-1],b_t_ramsey,'g :','LineWidth',2)
axis([0 time-1 0 b_max])
hold off
legend('Markov','Ramsey')
xlabel('time')
ylabel('debt')
title('panel d')
box off

% g_t_markov=g_t; tau_t_markov=tau_t; b_t_markov=b_t; 
% save data_markov g_t_markov tau_t_markov b_t_markov

% save data for two countries
if index_c == 1
    tau_x_c1=tau_x;
    g_x_c1=g_x;
    b1_x_c1=b1_x;
    g_gdp_c1=g_gdp;
    b_gdp_c1=b_gdp;
    b1_gdp_c1=b1_gdp;
    b1_linear_c1=b1_linear;
    b_t_c1=b_t;
    b_t_linear_c1=b_t_linear;
    save data_result_c1 time b_x tau_x_c1 g_x_c1 b1_x_c1 g_gdp_c1 b_gdp_c1 b1_gdp_c1 b_t_c1 b_t_linear_c1 b1_linear_c1
else
    tau_x_c2=tau_x;
    g_x_c2=g_x;
    b1_x_c2=b1_x;
    g_gdp_c2=g_gdp;
    b_gdp_c2=b_gdp;
    b1_gdp_c2=b1_gdp;
    b1_linear_c2=b1_linear;
    b_t_c2=b_t;
    b_t_linear_c2=b_t_linear;
    save data_result_c2 tau_x_c2 g_x_c2 b1_x_c2 g_gdp_c2 b_gdp_c2 b1_gdp_c2 b_t_c2 b_t_linear_c2 b1_linear_c2
end
    
% save data_plot_050 b_x b1_x tau_x g_x g_x

% figure (2)
% subplot(1,1,1)
% plot(b_x,b1_x,'g -','LineWidth',2)
% hold on
% plot(b_x,b_x,'k -')
% hold off
% box off
