clear

load regression_parameter

T=100;

% range of grids
% b_max_0=0.999*b_max; % 0.145944178104401; % 0.9*b_max;
% b_min_0=0;

% define function: g(t)=B(b(t)) 
for j=1:T
    b_x(j)=b_min_0+(j-1)*(b_max_0-b_min_0)/(T-1);
    yyy=feval('fun_result',b_x(j));
    g_x(j)=yyy(1,1); tau_x(j)=yyy(2,1);
    h_x(j)=(w*(1-tau_x(j))/X)^(1/xi);
    b1_x(j)=g_x(j)+R*b_x(j)-w*h_x(j)*tau_x(j);
    c_x(j)=h_x(j)*w*(1-tau_x(j))+F-1/(1+xi)*X*h_x(j)^(1+xi);
    g_gdp(j)=g_x(j)/(w*h_x(j));
    b_gdp(j)=b_x(j)/(w*h_x(j));
    b1_gdp(j)=b1_x(j)/(w*h_x(j));
end

figure (1)
subplot(3,1,1)
plot(b_x,tau_x,'b -','LineWidth',2)
% set(gca,'xtick',[0 0.05 0.10 0.15 0.22])
% set(gca,'ytick',[0.10 0.20 0.30 0.40 0.50])
axis([0 b_max 0.2 0.601])
xlabel('debt GDP ratio')
ylabel('tax rate')
title('panel a')
box off

subplot(3,1,2)
plot(b_gdp,g_gdp,'r -','LineWidth',2)
% set(gca,'xtick',[0 0.05 0.10 0.15 0.22])
% set(gca,'ytick',[0.05 0.10 0.15 0.20])
axis([0 max(b_gdp) 0 0.5])
xlabel('debt GDP ratio')
ylabel('public spending GDP ratio')
title('panel b')
box off

subplot(3,1,3)
plot(b_gdp,b1_gdp,'g -','LineWidth',2)
hold on
plot(b_gdp,b_gdp,'k -')
% set(gca,'xtick',[0 0.05 0.10 0.15 0.22])
% set(gca,'ytick',[0.05 0.10 0.15 0.22])
axis([0 max(b_gdp) 0 max(b_gdp)])
xlabel('debt GDP ratio')
ylabel('next-period debt GDP ratio')
title('panel c')
hold off
box off
