clear

tic

T=10;

for ii=1:T

xi=1.1-0.01*ii % 1/xi = Frisch elasticity
% xi=5.5 % 1/xi = Frisch elasticity

% R=6.31+0.0025*0.1*ii;
R=3.01-0.06;

for index_c=1:2
    
if index_c == 1
    the=0.3697; % relative weight on government expenditure for the young
else
    the=0.3937;
end
% parameter
the_o_y=0.8479/0.3818;
the_o=the*the_o_y; % theta for the old
alp=0.00; % relative weight on leisure
omi=0.25; % relative weight on the welfare of old households
% R=1.04^30; % gross interest rate
lam=0.0; % degree of altruism
phi=omi/(1-omi*(1-lam)); % useful parameter

% calibration
w=1; % normalization of wage rate
% xi=1.5; % 1/xi = Frisch elasticity

% bound for tax
tau_max=xi/(1+xi);
tau_min=0;

% calibration
X=1.2221;
F=X/(1+xi); % the original F_0: F_0-X/(1+xi)*h^(1/(1+xi))

% calibrate beta
bet=0.4420;

% bound for debt
h_max=(w*(1-tau_min)/X)^(1/xi);
b_max=(tau_max*(w*(1-tau_max)/X)^(1/xi)*w)/(R-1);
b_min=0;

% order of chebyshev polynomial
ord=8;

% number of state grids
num=ord;

% range of grids
b_max_0=1*b_max;
b_min_0=b_min;

% define debt in general chebyshev polynomials
for i=1:num
    % the chebyshev collocation 
    vb(i)=cos((num*2-1-(i-1)*2)*pi/(2*num));
    b(i)=((vb(i)+1)*(b_max_0-b_min_0)+2*b_min_0)/2;
    vb(i)=2*(b(i)-b_min)/(b_max-b_min)-1;
end

% define the derivative of vb w.r.t. b
d_vb=2/(b_max-b_min);

save regression_parameter bet the the_o alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb

if index_c == 1
    load solution_aa_1_c1
    initial_aa_1=solution_aa_1;
    options=optimset('Display','iter','LargeScale','off');
    [solution_aa_1,fval,exitflag,output,jacobian_0]=fsolve('projection_policy_1',initial_aa_1,options);
    solution_aa_1=real(solution_aa_1);
    save solution_aa_1_c1 solution_aa_1 
else
    load solution_aa_1_c2
    initial_aa_1=solution_aa_1;
    [solution_aa_1,fval,exitflag,output,jacobian_0]=fsolve('projection_policy_1',initial_aa_1,options);
    solution_aa_1=real(solution_aa_1);
    save solution_aa_1_c2 solution_aa_1 

end

if xi == 1
    save solution_aa_1_c1_xi_1 solution_aa_1 R
    save solution_aa_1_c2_xi_1 solution_aa_1 R
elseif xi == 3
    save solution_aa_1_c1_xi_3 solution_aa_1 R
    save solution_aa_1_c2_xi_3 solution_aa_1 R
elseif xi == 5
    save solution_aa_1_c1_xi_5 solution_aa_1 R
    save solution_aa_1_c2_xi_5 solution_aa_1 R
elseif xi == 10
    save solution_aa_1_c1_xi_10 solution_aa_1 R
    save solution_aa_1_c2_xi_10 solution_aa_1 R
elseif xi == 25
    save solution_aa_1_c1_xi_25 solution_aa_1 R
    save solution_aa_1_c2_xi_25 solution_aa_1 R
elseif xi == 30
    save solution_aa_1_c1_xi_30 solution_aa_1 R
    save solution_aa_1_c2_xi_30 solution_aa_1 R
elseif xi == 50
    save solution_aa_1_c1_xi_50 solution_aa_1 R
    save solution_aa_1_c2_xi_50 solution_aa_1 R
end

end % index

end % simple continuation