clear

load regression_parameter

load data_ss

time=21;

% initial state
b_t(1)=b_ss;

for t=1:time-1
    yyy=feval('fun_result',b_t(t));
    g_t(t)=yyy(1,1); tau_t(t)=yyy(2,1);
    h_t(t)=(w*(1-tau_t(t))/X)^(1/xi);
    b_t(t+1)=g_t(t)+R*b_t(t)-w*h_t(t)*tau_t(t);
    g_gdp(t)=g_t(t)/(w*h_t(t));
    b_gdp(t)=b_t(t)/(w*h_t(t));
    if t == 2 % time for war
        z=0.01*gdp_ss; % cost of war
        yyy=feval('fun_result',b_t(t)+z/R);
        g_t(t)=yyy(1,1); tau_t(t)=yyy(2,1);
        h_t(t)=(w*(1-tau_t(t))/X)^(1/xi);
        b_t(t+1)=g_t(t)+R*b_t(t)+z-w*h_t(t)*tau_t(t);
        g_gdp(t)=g_t(t)/(w*h_t(t));
        b_gdp(t)=b_t(t)/(w*h_t(t));
    end
end

xxx=feval('fun_result',b_t(time));
g_t(time)=xxx(1,1);
tau_t(time)=xxx(2,1);
h_t(time)=(w*(1-tau_t(time))/X)^(1/xi);
g_gdp(time)=g_t(time)/(w*h_t(time));
b_gdp(time)=b_t(time)/(w*h_t(time));

t=[0:time-1];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% step function equilibrium
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% example
bet=0.985^30; % subjective discounting rate
the=1; % relative weight on government expenditure
alp=0.00; % relative weight on leisure
omi=0.50; % relative weight on the welfare of old households
R=1.05^30; % gross interest rate
lam=0.0; % degree of altruism
phi=omi/(1-omi*(1-lam)); % useful parameter
tau_max=0.6; 
z=0.01;

b_max_step=tau_max/(R-1);
b_t_step(1:time)=b_max_step*(1-the*(1+phi)*(1-tau_max)/(tau_max*(1+bet)));
tau_t_step(1:time)=tau_max;
g_t_step(1:time)=the*(1+phi)*(1-tau_max)/(1+bet);
g_t_step(2)=b_t_step(3)-R*b_t_step(2)+tau_max-z;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% compute percentage change
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

d_tau_t=(tau_t-tau_ss)/tau_ss;
d_g_t=(g_t-g_ss)/g_ss;
d_b_t=(b_t-b_ss)/b_ss;
d_tau_t_step=(tau_t_step-tau_t_step(1))/tau_t_step(1);
d_g_t_step=(g_t_step-g_t_step(1))/g_t_step(1);
d_b_t_step=(b_t_step-b_t_step(1))/b_t_step(1);

%%%%%%%%%%%
% figures
%%%%%%%%%%%

% subplot(2,1,1)
% plot(t,100*d_tau_t,'k','linewidth',2)
% gtext('tax rate')
% hold on
% plot(t,100*d_g_t,'color','r','linewidth',2)
% gtext('public spending')
% hold on
% plot(t,100*d_b_t,'g','linewidth',2)
% gtext('debt')
% xlabel('time')
% ylabel('percentage deviation from the steady state')
% title('panel a')
% box off
% 
% subplot(2,1,2)
% plot(t,100*d_tau_t_step,'k','linewidth',2)
% gtext('tax rate')
% hold on
% plot(t,100*d_g_t_step,'color','r','linewidth',2)
% gtext('public spending')
% hold on
% % plot(t,100*d_b_t_step,'g','linewidth',2)
% % gtext('debt')
% xlabel('time')
% ylabel('percentage deviation from the steady state')
% title('panel b')
% 
box off
hold off

t_war=t;  d_tau_t_war=d_tau_t;  d_g_t_war=d_g_t; d_b_t_war=d_b_t;
save data_war t_war d_tau_t_war d_g_t_war d_b_t_war

subplot(1,1,1)
plot(t,100*d_tau_t,'k','linewidth',2)
gtext('tax rate')
hold on
plot(t,100*d_g_t,'color','r','linewidth',2)
gtext('public spending')
hold on
plot(t,100*d_b_t,'g','linewidth',2)
gtext('debt')
xlabel('time')
ylabel('percentage deviation from the steady state')
box off
