clear

load regression_parameter

time=10;

% n shock
n=1.01^30;

load data_ss

% first state
b_t(1)=b_ss*2/(1+n);
data_b=b_t(1);
save data_b data_b n
% options=optimset('Display','iter','LargeScale','off');
options=optimset('Display','iter','LargeScale','off','TolFun',1e-20);
yyy=fsolve('fun_first_period',[0.2253; 0.4018],options);
g_t(1)=real(yyy(1,1)); tau_t(1)=real(yyy(2,1));
h_t(1)=(w*(1-tau_t(1))/X)^(1/xi);
b_t(2)=(1+n)/(2*n)*g_t(1)+(1+n)/(2*n)*R*b_t(1)-n*w*h_t(1)*tau_t(1);

% stationary demography
for t=2:time-1
    yyy=feval('fun_result',b_t(t));
    g_t(t)=yyy(1,1); tau_t(t)=yyy(2,1);
    h_t(t)=(w*(1-tau_t(t))/X)^(1/xi);
    b_t(t+1)=g_t(t)+R*b_t(t)-w*h_t(t)*tau_t(t);
end

xxx=feval('fun_result',b_t(time));
g_t(time)=xxx(1,1);
tau_t(time)=xxx(2,1);
h_t(time)=(w*(1-tau_t(time))/X)^(1/xi);

load data_ss g_ss tau_ss b_ss gdp_ss

d_tau_t(1)=0; d_g_t(1)=0; d_b_t(1)=0;
d_tau_t(2:time+1)=(tau_t-tau_ss)/tau_ss;
d_g_t(2:time+1)=(g_t-g_ss)/g_ss;
d_b_t(2:time+1)=(b_t-b_ss)/b_ss;

%%%%%%%%%%%
% figures
%%%%%%%%%%%

subplot(1,1,1)
plot([0:time],100*d_b_t,'g -','linewidth',2)
gtext('debt')
hold on
plot([0:time],100*d_g_t,'r -','linewidth',2)
gtext('public spending')
hold on
plot([0:time],100*d_tau_t,'k -','linewidth',2)
gtext('tax rate')
hold off
xlabel('time')
ylabel('percentage deviation from the steady state')
box off
