function ff=fun_first_period(x)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% the first period policy after a transitory demographic shock
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load regression_parameter

load data_b

load solution_aa_1
aa=solution_aa_1;

% real
aa=real(aa);

% input
g=x(1,1);
tau=x(2,1);

%%%%%%%%%%%%
% FUNCTION
%%%%%%%%%%%%

% labour supply, its derivative and the elasticity of labor supply
h=(w*(1-tau)/X)^(1/xi);
e=1/xi*tau/(1-tau);

% calculate debt in the next period
b1=(1+n)/(2*n)*g+(1+n)/(2*n)*R*data_b-n*w*tau*h;
        
% define function: g(t+1)=G(b(t+1)) and its derivatives w.r.t. b(t+1)
% note that b(t+1) must fall in the range of b(t)
vb1=2*(b1-b_min)/(b_max-b_min)-1;

% define function: g(t+1)=G(b(t+1)) and its derivatives w.r.t. b(t+1)
for s=1:ord
    % denote by che_tau_1 the T in chebyshev polynomial
    che_b1(s)=cos((s-1)*acos(vb1));
    % derivatives w.r.t. b(t+1)
    d_che_b1(s)=sin((s-1)*acos(vb1))*(s-1)/(1-vb1^2)^(1/2)*d_vb;
end
% elements of (t+1)=G(b(t+1)) and its derivatives w.r.t. b(t+1)
for t=1:ord
    g1_aa(t)=aa(t)*che_b1(t);
    d_g1_aa(t)=aa(t)*d_che_b1(t);
end
% function: g(t+1)=G(b(t+1)) 
g1=sum(g1_aa);
% derivatives w.r.t. b(t+1)
d_g1_b=sum(d_g1_aa);

%%%%%%%%%%%%% 
% Equations
%%%%%%%%%%%%%

% political weight
phi=omi/(1-omi); % useful parameter

% life-time wealth
A=(1-tau)*w*h+F-X/(1+xi)*h^(1+xi)+F/R;

% equations
ff(1,1)=A*(1-e)-(1+bet)/(1+omi/((1-omi)*n)*the_o/the)*g/the;
ff(2,1)=-bet*the_o/the*d_g1_b/((omi/((1-omi)*n)*the_o/the+1)*g1)-1/g;

xxx=1;

% solution_aa_1=aa;
% save solution_aa_1 solution_aa_1
