load regression_parameter

load solution_aa_1
aa=solution_aa_1;

% real
aa=real(aa);

%%%%%%%%%%%%
% FUNCTION
%%%%%%%%%%%%

num_grid=1000;
for j=1:num_grid

        b(j)=b_min+(j-1)*(0.99*b_max-b_min)/(num_grid-1); 
        vb(j)=2*(b(j)-b_min)/(b_max-b_min)-1;

        % define function: g(t)=G(b(t)) and tau(t)=T(b(t))
        for s=1:ord
            % denote by che_b the terms in chebyshev polynomial
            che_b(s)=cos((s-1)*acos(vb(j)));
        end
        % elements of g(t)=G(b(t))
        for t=1:ord
            g_aa(t)=aa(t)*che_b(t);
            tau_aa(t)=aa(ord+t)*che_b(t);
        end
        % function: g(t)=G(b(t)) and tau(t)=T(b(t))
        g(j)=sum(g_aa);
        tau(j)=sum(tau_aa);
        
        % labour supply, its derivative and the elasticity of labor supply
        h(j)=(w*(1-tau(j))/X)^(1/xi);
        e(j)=1/xi*tau(j)/(1-tau(j));
        
        % calculate debt in the next period
        b1(j)=g(j)+R*b(j)-w*tau(j)*h(j);
        % b1(j)=min(0.999*b_max,b1(j));
        
        % define function: g(t+1)=G(b(t+1)) and its derivatives w.r.t. b(t+1)
        % note that b(t+1) must fall in the range of b(t)
        vb1(j)=2*(b1(j)-b_min)/(b_max-b_min)-1;

        % define function: g(t+1)=G(b(t+1)) and its derivatives w.r.t. b(t+1)
        for s=1:ord
            % denote by che_tau_1 the T in chebyshev polynomial
            che_b1(s)=cos((s-1)*acos(vb1(j)));
            % derivatives w.r.t. b(t+1)
            d_che_b1(s)=sin((s-1)*acos(vb1(j)))*(s-1)/(1-vb1(j)^2)^(1/2)*d_vb;
        end
        % elements of (t+1)=G(b(t+1)) and its derivatives w.r.t. b(t+1)
        for t=1:ord
            g1_aa(t)=aa(t)*che_b1(t);
            d_g1_aa(t)=aa(t)*d_che_b1(t);
        end
        % function: g(t+1)=G(b(t+1)) 
        g1(j)=sum(g1_aa);
        % derivatives w.r.t. b(t+1)
        d_g1_b(j)=sum(d_g1_aa);
        
        %%%%%%%%%%%%% 
        % Equations
        %%%%%%%%%%%%%
        
        % life-time wealth
        A(j)=(1-tau(j))*w*h(j)+F-X/(1+xi)*h(j)^(1+xi);
        
        % equations
        ff_1(j,1)=A(j)*(1-e(j))-(1+bet)/(the*(1+phi))*g(j);
        % ff(num+j,1)=bet*lam*R/g1(j)+bet*lam*phi*d_g1_b(j)/((1+phi)*g1(j))-bet*d_g1_b(j)/((1+phi)*g1(j))-1/g(j);
        ff_2(j,1)=bet*lam*R+bet*lam*phi*d_g1_b(j)/(1+phi)-bet*d_g1_b(j)/(1+phi)-g1(j)/g(j);

end
subplot(2,1,1)
plot(b,ff_1)
title('deviation from the intratemporal FOC')
subplot(2,1,2)
plot(b,ff_2)
title('deviation from the GEE')
