clear

tic

T=10;

load solution_aa_1_ini
save solution_aa_1 solution_aa_1 

for ii=1:T

xi=2400-5*ii % 1/xi = Frisch elasticity

% parameter
bet=0.98^30; % subjective discounting rate
the=0.09; % relative weight on government expenditure
alp=0.00; % relative weight on leisure
omi=0.50; % relative weight on the welfare of old households
R=1.025^30; % gross interest rate
lam=0.7905; % degree of altruism
phi=omi/(1-omi*(1-lam)); % useful parameter

% calibration
w=1; % normalization of wage rate
X=1; % coefficient of home production
% tau_target=0.2728; % targeted steady state tax rate

tau_max=xi/(1+xi);
b_max=tau_max*(w*(1-tau_max)/X)^(1/xi)*w/(R-1);
b_min=0;
b_max=w/(R-1);

tau_min=0;
h_max=(w*(1-tau_min)/X)^(1/xi);
F=X/(1+xi)*h_max^(1+xi); % such that home products equal zero with tau=0

% order of chebyshev polynomial
ord=15;

% number of state grids
num=ord;

% range of grids
b_max_0=0.999*b_max;
b_min_0=0;

% define debt in general chebyshev polynomials
for i=1:num
    % the chebyshev collocation 
    vb(i)=cos((num*2-1-(i-1)*2)*pi/(2*num));
    b(i)=((vb(i)+1)*(b_max_0-b_min_0)+2*b_min_0)/2;
    vb(i)=2*(b(i)-b_min)/(b_max-b_min)-1;
end

% define the derivative of vb w.r.t. b
d_vb=2/(b_max-b_min);

save regression_parameter bet the alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb

load solution_aa_1
initial_aa_1=solution_aa_1;

% solving
% options=optimset('Display','iter','LargeScale','off');
options=optimset('Display','iter','LargeScale','off','NonlEqnAlgorithm','gn','MaxIter',20,'TolFun',1e-30,'TolX',1e-20);
[solution_aa_1,fval,exitflag,output,jacobian_0]=fsolve('projection_policy_1',initial_aa_1,options);
if exitflag == 0
    xxx=1;
end

solution_aa_1=real(solution_aa_1);

save solution_aa_1 solution_aa_1 

end