function y=fun_kks_third(bb)

global data_b kap_G kap_T bet the alp omi R xi lam phi w F X

data_b=bb;
options=optimset('Display','off','LargeScale','off','MaxIter',50,'TolFun',1e-30,'TolX',1e-20);
tau=fsolve('fun_tau',0.4,options);
h=(w*(1-tau)/X)^(1/xi);
e=1/xi*tau/(1-tau);
A=(1-tau)*w*h+F-X/(1+xi)*h^(1+xi)+F/R;
g=(1-e)*A/kap_T;

% first-order differentiation
d_G=kap_G;
d_e=1/xi*1/(1-tau)^2;
d_h=-1/xi*(w/X)^(1/xi)*(1-tau)^(1/xi-1);
d_A=-w*h;
d_T=kap_T*d_G/(-d_e*A+(1-e)*d_A);
d_B=d_G+R-d_T*w*h*(1-e);

% second-order differentiation
dd_G=(kap_G*d_G*d_B-d_G^2)/(d_B*g);
dd_e=1/xi*2/(1-tau)^3;
dd_h=1/xi*(w/X)^(1/xi)*(1/xi-1)*(1-tau)^(1/xi-2);
dd_A=-w*d_h;
dd_T=(kap_T*dd_G-(-dd_e*A+2*(-d_e)*d_A+(1-e)*dd_A)*d_T^2)/(-d_e*A+(1-e)*d_A);
dd_B=dd_G-dd_T*w*h*(1-e)-d_T^2*w*d_h*(1-e)-d_T^2*w*h*(-d_e);

% third-order differentiation
ddd_G=(kap_G*dd_G*d_B^2+kap_G*d_G*dd_B-dd_G*dd_B*g-2*dd_G*d_B*d_G-dd_G*d_G)/(d_B^2*g);
ddd_e=1/xi*6/(1-tau)^4;
ddd_A=-w*dd_h;
ddd_T=(kap_T*ddd_G-(-ddd_e*A+3*(-dd_e)*d_A+3*(-d_e)*dd_A+(1-e)*ddd_A)*d_T^3-2*(-dd_e*A+2*(-d_e)*d_A+(1-e)*dd_A)*d_T*dd_T)/(-d_e*A+(1-e)*d_A);
ddd_B=ddd_G-ddd_T*w*h*(1-e)-3*dd_T*d_T*w*d_h*(1-e)-3*dd_T*d_T*w*h*(-d_e)-d_T^3*w*dd_h*(1-e)-2*d_T^3*w*d_h*(-d_e)-d_T^3*w*h*(-dd_e);

% fourth-order differentiation
para=3*ddd_G*d_B*dd_B*g+3*ddd_G*d_B^2*d_G+dd_G*ddd_B*g+3*dd_G*dd_B*d_G+3*dd_G*d_B*dd_G+ddd_G*d_G;
dddd_G=(kap_G*ddd_G*d_B^3+3*kap_G*dd_G*d_B*dd_B+kap_G*d_G*ddd_B-para)/(d_B^3*g);

y=dddd_G;