function y=fun_regression_parameter(the_c)
    
global data_b kap_G kap_T bet the the_o alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb

% target
b_gdp_target_c1=0.025*3/2;

% fixing the ratio of theta_o to theta_y
the_o_y=0.8479/0.3818;

%*********************************
% the country with fixed theta
%*********************************

% parameter
the=the_c(1); % relative weight on government expenditure
the_o=the_c(1)*the_o_y; % 0.9163; % theta for the old
alp=0.00; % relative weight on leisure
omi=0.25; % relative weight on the welfare of old households
R=1.04^30; % gross interest rate
lam=0; % degree of altruism
phi=omi/(1-omi*(1-lam)); % useful parameter

% targeted wealth income ratio
k_gdp_target=1/2/(R);

% calibration
w=1; % normalization of wage rate
xi=1.50; % 1/xi = Frisch elasticity
X=1; % coefficient of home production

% bound for tax
tau_max=xi/(1+xi);
tau_min=0;

% calibration
tau_target=0.407; % targeted steady state tax rate
me_target=33/(51-33); % market earnings/home earnings ratio
save regression_parameter w xi tau_target me_target
options=optimset('Display','off','LargeScale','off','MaxIter',50,'TolFun',1e-30,'TolX',1e-20);
X=fsolve('fun_X',1,options);
h_target=(w*(1-tau_target)/X)^(1/xi); % market hours
home_target=X/(1+xi)*(1-h_target^(1+xi)); % home production
F=X/(1+xi); % the original F_0: F_0-X/(1+xi)*h^(1/(1+xi))
% F=(1/me_target-1)*w*(1-tau_target)*h_target+X/(1+xi)*h_target^(1+xi);
% F=X/(1+xi)*h_max^(1+xi); % such that home products equal zero with tau=0

% calibrate beta
b_gdp_target=(0.025+0.012)*3/2/2;
k_b_gdp_target=k_gdp_target+b_gdp_target;
bet=(F/(w*h_target)/R+k_b_gdp_target)/(51/33-tau_target-k_b_gdp_target);
bet^(1/30);

% parameters
kap_G=-(1+omi*(the_o_y-1))/((1-omi)*the_o_y*bet);
kap_T=(1-omi)*(1+bet)/(the*(1+omi*(the_o_y-1)));

% bound for debt
h_max=(w*(1-tau_min)/X)^(1/xi);
b_max=(tau_max*(w*(1-tau_max)/X)^(1/xi)*w)/(R-1);
b_min=0;

% order of chebyshev polynomial
ord=15;

% number of state grids
num=ord;

% range of grids
b_max_0=1*b_max;
b_min_0=0;

% define debt in general chebyshev polynomials
for i=1:num
    % the chebyshev collocation 
    vb(i)=cos((num*2-1-(i-1)*2)*pi/(2*num));
    b(i)=((vb(i)+1)*(b_max_0-b_min_0)+2*b_min_0)/2;
    vb(i)=2*(b(i)-b_min)/(b_max-b_min)-1;
end

% define the derivative of vb w.r.t. b
d_vb=2/(b_max-b_min);

save regression_parameter bet the the_o alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb

options=optimset('Display','off','LargeScale','off','MaxIter',50,'TolFun',1e-30,'TolX',1e-20);
debt_1=fsolve('fun_kks_second',0.0231,options);
% debt_1=fsolve('fun_kks_third',0.0231,options);

data_b=debt_1;
tau_1=fsolve('fun_tau',0.4,options);
h_1=(w*(1-tau_1)/X)^(1/xi);
e_1=1/xi*tau_1/(1-tau_1);
A_1=(1-tau_1)*w*h_1+F-X/(1+xi)*h_1^(1+xi)+F/R;
g_1=(1-e_1)*A_1/kap_T;
gdp_1=w*h_1;
inc_1=h_1*w*(1-tau_1)+F-1/(1+xi)*X*h_1^(1+xi); % income of the young
con_1=1/(1+bet)*(h_1*w*(1-tau_1)+F-1/(1+xi)*X*h_1^(1+xi)+F/R); % consumption of the young
saving_1=inc_1-con_1;
sr_1=saving_1/(h_1*w*(1-tau_1));

%*********************************
% the country with fixed theta
%*********************************

% parameter
the=the_c(2); % relative weight on government expenditure
the_o=the_c(2)*the_o_y; % 0.9163; % theta for the old

% parameters
kap_G=-(1+omi*(the_o_y-1))/((1-omi)*the_o_y*bet);
kap_T=(1-omi)*(1+bet)/(the*(1+omi*(the_o_y-1)));

save regression_parameter bet the the_o alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb

debt_2=fsolve('fun_kks_second',0.0231,options);
% debt_2=fsolve('fun_kks_third',0.0231,options);

data_b=debt_2;
tau_2=fsolve('fun_tau',0.4,options);
h_2=(w*(1-tau_2)/X)^(1/xi);
e_2=1/xi*tau_2/(1-tau_2);
A_2=(1-tau_2)*w*h_2+F-X/(1+xi)*h_2^(1+xi)+F/R;
g_2=(1-e_2)*A_2/kap_T;
gdp_2=w*h_2;
inc_2=h_2*w*(1-tau_2)+F-1/(1+xi)*X*h_2^(1+xi); % income of the young
con_2=1/(1+bet)*(h_2*w*(1-tau_2)+F-1/(1+xi)*X*h_2^(1+xi)+F/R); % consumption of the young
saving_2=inc_2-con_2;
sr_2=saving_2/(h_2*w*(1-tau_2));

% equation
k_gdp=(saving_1+saving_2-debt_1-debt_2)/(gdp_1+gdp_2);
y(1)=debt_1/gdp_1-b_gdp_target_c1;
y(2)=k_gdp-k_gdp_target;

save two_country_ss tau_1 g_1 gdp_1 sr_1 debt_1 tau_2 g_2 gdp_2 debt_2 sr_2