clear

% country index
index_c=1; % index_c = 1 for country with LOWER theta !!!
if index_c == 1
    the=0.3697; % relative weight on government expenditure for the young
else
    the=0.3937;
end
% parameter
the_o_y=0.8479/0.3818;
the_o=the*the_o_y; % theta for the old
% **** Note that alp = 1/3 cannot be adjusted ****
alp=1/3; % capital output elasticity 
% **** Note that alp = 1/3 cannot be adjusted ****
omi=0.25; % relative weight on the welfare of old households
R=1.04^30; % gross interest rate
lam=0.0; % degree of altruism
phi=omi/(1-omi*(1-lam)); % useful parameter

% targeted wealth income ratio
k_gdp_target=1/2/(R);

% calibration
Q=(1/((1-alp)*(alp/1.04^30)^(alp/(1-alp))))^(1-alp);
w=(1-alp)*Q^(1/(1-alp))*(alp/R)^(alp/(1-alp)); % normalization of wage rate
xi=1.50; % 1/xi = Frisch elasticity
X=1; % coefficient of home production

% bound for tax
tau_max=xi/(1+xi);
tau_min=0;

% calibration
tau_target=0.407; % targeted steady state tax rate
me_target=33/(51-33); % market earnings/home earnings ratio
save regression_parameter w xi tau_target me_target
options=optimset('Display','off','LargeScale','off','MaxIter',50,'TolFun',1e-30,'TolX',1e-20);
X=fsolve('fun_X',1,options);
h_target=(w*(1-tau_target)/X)^(1/xi); % market hours
home_target=X/(1+xi)*(1-h_target^(1+xi)); % home production
F=X/(1+xi); % the original F_0: F_0-X/(1+xi)*h^(1/(1+xi))
% F=(1/me_target-1)*w*(1-tau_target)*h_target+X/(1+xi)*h_target^(1+xi);
% F=X/(1+xi)*h_max^(1+xi); % such that home products equal zero with tau=0

% calibrate beta
b_gdp_target=(0.025+0.012)*3/2/2;
k_b_gdp_target=k_gdp_target+b_gdp_target;
bet=(F/(w*h_target)/R+k_b_gdp_target)/(51/33-tau_target-k_b_gdp_target);
bet^(1/30)

% bound for debt
h_max=(w*(1-tau_min)/X)^(1/xi);
b_max=(tau_max*(w*(1-tau_max)/X)^(1/xi)*w)/(R-1);
b_min=0;

% order of chebyshev polynomial
ord=15;

% number of state grids
num=ord;

% range of grids
b_max_0=1*b_max;
b_min_0=0;

% define debt in general chebyshev polynomials
for i=1:num
    % the chebyshev collocation 
    vb(i)=cos((num*2-1-(i-1)*2)*pi/(2*num));
    b(i)=((vb(i)+1)*(b_max_0-b_min_0)+2*b_min_0)/2;
    vb(i)=2*(b(i)-b_min)/(b_max-b_min)-1;
end

% define the derivative of vb w.r.t. b
d_vb=2/(b_max-b_min);

save regression_parameter bet the the_o alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb

if index_c == 1
    save regression_parameter_c1 bet the the_o alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb
    load solution_aa_1_c1
else
    save regression_parameter_c2 bet the the_o alp omi R xi lam phi w F tau_max b_max b_min b_max_0 b_min_0 X w ord num vb b d_vb
    load solution_aa_1_c2
end
initial_aa_1=solution_aa_1;

% solving
options=optimset('Display','iter','LargeScale','off','NonlEqnAlgorithm','gn','MaxIter',50,'TolFun',1e-30,'TolX',1e-20);
[solution_aa_1,fval,exitflag,output,jacobian_0]=fsolve('projection_policy_1',initial_aa_1,options);
save solution_aa_1 solution_aa_1

if index_c == 1
    save solution_aa_1_c1 solution_aa_1
else
    save solution_aa_1_c2 solution_aa_1
end

% result